import * as React from 'react';
/**
 * Viewport component allow tracking the component when it appears in the viewport
 */
export declare class Viewport extends React.Component<Props> {
    static defaultProps: Partial<DataProps>;
    private readonly screenRef;
    private isInScreen;
    private timer;
    private counter;
    private flag;
    constructor(props: Props);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private handleScroll;
    private handleLoad;
    private handleEnter;
    private handleLeave;
    private getWidthHeight;
    private startTimer;
    private resetTimer;
    private sleep;
    private setInternalFlag;
    private setInternalCounter;
}
declare type Props = DataProps & EventProps;
interface DataProps {
    /** React component node */
    children: JSX.Element | JSX.Element[] | string;
    /** Delay time for scroll event */
    delay?: number;
    /** Type of check component if it is in the viewport */
    type?: Type;
    /** Id of element */
    id?: string;
    /** Custom CSS class */
    className?: string;
    /** Enable auto track, this feature only work in "fit" mode */
    autoTrack?: boolean;
    /** Wait to start counter for auto track, this feature only work in "fit" mode */
    waitToStartAutoTrack?: number;
}
interface EventProps {
    /** When component is mounted */
    onLoad?: () => void;
    /** When component is in the viewport, event will be executed */
    onEnter?: (enterTimes?: number) => void;
    /** When component is not in the viewport, event will be executed */
    onLeave?: (leaveTimes?: number) => void;
    /** When component is not focused the viewport, event will be executed */
    onFocusOut?: (focusTimes?: number) => void;
}
export interface Size {
    width: number;
    height: number;
}
declare type Type = 'fit' | 'overlap';
export {};
